﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.Map;

namespace ClusteredDataSourceSample
{
	public partial class MainPage : UserControl
	{
		private Random rnd = new Random();

		public MainPage()
		{
			InitializeComponent();
		}

		private void ClusterMouseClick(object sender, MouseButtonEventArgs e)
		{
			FrameworkElement element = sender as FrameworkElement;
			if (element != null)
			{
				ClusterItem cluster = element.DataContext as ClusterItem;
				if (cluster != null)
				{
					if (cluster.ClusterState == ClusterState.ExpandedToPolygon
						|| cluster.ClusterState == ClusterState.Expanded)
					{
						cluster.ClusterState = ClusterState.Collapsed;
					}
					else
					{
						cluster.HideExpanded = false;
						cluster.ClusterState = ClusterState.ExpandedToPolygon;
					}
				}
			}
		}

		private void ClusterRightMouseDown(object sender, MouseButtonEventArgs e)
		{
			e.Handled = true;
		}

		private void ClusterRightMouseClick(object sender, MouseButtonEventArgs e)
		{
			FrameworkElement element = sender as FrameworkElement;
			if (element != null)
			{
				ClusterItem cluster = element.DataContext as ClusterItem;
				if (cluster != null)
				{
					cluster.HideExpanded = true;
					cluster.ClusterState = ClusterState.Expanded;
				}
			}

			e.Handled = true;
		}

		private void ClusteredItemMouseClick(object sender, MouseButtonEventArgs e)
		{
			FrameworkElement element = sender as FrameworkElement;
			if (element != null)
			{
				ClusteredItem item = element.DataContext as ClusteredItem;
				if (item != null)
				{
					ClusteredDataSource dataSource = item.DataSource;
					if (dataSource != null)
					{
						dataSource.Collapse(item.Data);
					}
				}
			}
		}
	}
}
