﻿using System;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls.Map;

namespace ClusteredDataSourceSample
{
	public class MassiveDataSource : ObservableCollection<Location>
	{
		private Random rnd = new Random();
		private LocationRect dataRectangle = new LocationRect();
		private Location geoBoundsNW = Location.Empty;
		private Location geoBoundsSE = Location.Empty;

		public MassiveDataSource()
		{
		}

		public LocationRect DataRectangle
		{
			get
			{
				return this.dataRectangle;
			}

			set
			{
				this.dataRectangle = value;
				this.CreatePointsInRect(1000);
			}
		}

		public Location GeoBoundsNW
		{
			get
			{
				return this.geoBoundsNW;
			}

			set
			{
				this.geoBoundsNW = value;
				this.UpdateGeoBounds();
			}
		}

		public Location GeoBoundsSE
		{
			get
			{
				return this.geoBoundsSE;
			}

			set
			{
				this.geoBoundsSE = value;
				this.UpdateGeoBounds();
			}
		}

		private void CreatePointsInRect(int count)
		{
			if (!this.dataRectangle.IsEmpty)
			{
				for (int i = 0; i < count; i++)
				{
					Location loc = new Location(
						this.DataRectangle.North - this.DataRectangle.GeoSize.Height * rnd.NextDouble(),
						this.DataRectangle.West + this.DataRectangle.GeoSize.Width * rnd.NextDouble());

					this.Add(loc);
				}
			}
		}

		private void UpdateGeoBounds()
		{
			if (!this.GeoBoundsNW.IsEmpty && !this.GeoBoundsSE.IsEmpty)
			{
				this.DataRectangle = new LocationRect(this.GeoBoundsNW, this.GeoBoundsSE);
			}
		}
	}
}
